// NewFolder.cpp : Implementation of CNewFolder
#include "stdafx.h"
#include "ATLtest.h"
#include "NewFolder.h"

static WNDPROC g_pfnExplorerWndProc = NULL;
static HHOOK g_hHook = NULL;
static HWND g_hwndExplorer = NULL;

/////////////////////////////////////////////////////////////////////////////
// CNewFolder
CNewFolder::~CNewFolder()
{
	if(m_bSubclassed)
	{
		SubclassExplorer(false);
		m_bSubclassed = false;
	}
}

STDMETHODIMP CNewFolder::SetSite(IUnknown* pUnkSite)
{
	HRESULT hr = SubclassExplorer(true);
	if(SUCCEEDED(hr))
		m_bSubclassed = true;

	return S_OK;
}

STDMETHODIMP CNewFolder::SubclassExplorer(bool bSubclass)
{
	EnumThreadWindows(GetCurrentThreadId(), WndEnumProc, reinterpret_cast<LPARAM>(&m_hwndExplorer));

	if(!IsWindow(m_hwndExplorer))
		return E_FAIL;
	else
		g_hwndExplorer = m_hwndExplorer;

	if(bSubclass && !m_bSubclassed)
	{
		g_pfnExplorerWndProc = reinterpret_cast<WNDPROC>(SetWindowLong(m_hwndExplorer, 
			GWL_WNDPROC, reinterpret_cast<LONG>(NewExplorerWndProc)));

		g_hHook = SetWindowsHookEx(WH_KEYBOARD, KeyBoardProc, NULL, GetCurrentThreadId());
	}

	if(!bSubclass && m_bSubclassed)
	{
		SetWindowLong(m_hwndExplorer, GWL_WNDPROC, reinterpret_cast<LONG>(g_pfnExplorerWndProc));

		UnhookWindowsHookEx(g_hHook);
	}

	return S_OK;
}	
	
BOOL CALLBACK CNewFolder::WndEnumProc(HWND hwnd, LPARAM lParam)
{
	TCHAR szClassName[MAX_PATH] = {0};
	GetClassName(hwnd, szClassName, MAX_PATH);

	if(!lstrcmpi(szClassName, __TEXT("ExploreWClass")))
	{
		HWND* phwnd = reinterpret_cast<HWND*>(lParam);
		*phwnd = hwnd;

		return FALSE;
	}

	return TRUE; 
}

LRESULT CALLBACK CNewFolder::KeyBoardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode < 0)
		return CallNextHookEx(g_hHook, nCode, wParam, lParam);

	if((lParam & 0x80000000) || (lParam & 0x40000000))
		return CallNextHookEx(g_hHook, nCode, wParam, lParam);

	if(wParam == NewFolderKey)
		PostMessage(g_hwndExplorer, WM_COMMAND, NewFolderMsg, 0);

	return CallNextHookEx(g_hHook, nCode, wParam, lParam);
}

LRESULT CALLBACK CNewFolder::NewExplorerWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return CallWindowProc(g_pfnExplorerWndProc, hwnd, uMsg, wParam, lParam);
}
