// NewFolder.h : Declaration of the CNewFolder

#ifndef __NEWFOLDER_H_
#define __NEWFOLDER_H_

#include "resource.h"       // main symbols

const int NewFolderMsg = 29281;
const int NewFolderKey = VK_F12;
const int DeleteKey = VK_DELETE;

/////////////////////////////////////////////////////////////////////////////
// CNewFolder
class ATL_NO_VTABLE CNewFolder : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CNewFolder, &CLSID_NewFolder>,
	public IObjectWithSiteImpl<CNewFolder>,
	public IDispatchImpl<INewFolder, &IID_INewFolder, &LIBID_ATLTESTLib>
{
public:
	CNewFolder()
	{
		m_bSubclassed = false; 
	}
   ~CNewFolder();

DECLARE_REGISTRY_RESOURCEID(IDR_NEWFOLDER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CNewFolder)
	COM_INTERFACE_ENTRY(INewFolder)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IObjectWithSite)
END_COM_MAP()

// INewFolder
public:
	STDMETHOD(SubclassExplorer)(bool bSubclass);

// IObjctWithSite
public:
	STDMETHOD(SetSite)(IUnknown* pUnkSite);

private:
	bool m_bSubclassed;
	HWND m_hwndExplorer;

	static BOOL CALLBACK WndEnumProc(HWND, LPARAM);
	static LRESULT CALLBACK KeyBoardProc(int, WPARAM, LPARAM);
	static LRESULT CALLBACK NewExplorerWndProc(HWND, UINT, WPARAM, LPARAM);

};

#endif //__NEWFOLDER_H_
